#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include "AdjList.h"

int main(int argc, char *argv[]) {
   int qV, qE, i, j;
   Vertex v, w; // arc/edge input variables

   // cria ponteiro e aloca dinamicamente qtde de arcos
   
   
/* 
   Graph G;
   G = initDigraph(5);
   insertArc(G,0,1,5);
   insertArc(G,0,2,1);
   insertArc(G,1,3,3);
   insertArc(G,2,1,2);
   insertArc(G,2,3,9);
   insertArc(G,2,3,9);
   insertArc(G,3,2,2);
   
   printDigraph(G);*/

   Graph G;
   G = initGraph(6);
   insertEdge(G,0,1,2);
   insertEdge(G,0,3,5);
   insertEdge(G,1,2,8);
   insertEdge(G,1,3,6);
   insertEdge(G,2,3,3);
   insertEdge(G,2,4,5);
   insertEdge(G,3,4,6);
   
   printGraph(G);

   double *dist = (double *) calloc(G->V,sizeof(double));
   int *pred = (int *) calloc(G->V,sizeof(int));
   
   dijkstra(G, 0, dist, pred);
   
   printf("Distancias a partir de 0: \n");
   for (i = 0; i < G->V; i++) {
	printf("%d = %.2f (de %d)\n",i, distances[i], pred[i]);
   }
   printf("\n");
   
   free(dist);
   free(pred);
   
   dist = (double *) calloc(G->V,sizeof(double));
   pred = (int *) calloc(G->V,sizeof(int));

   prim(G, 0, dist, pred);
   
   printf("Arvore Geradora Minima (prim) a partir de 0: ");
   j = 0;
   while (j <= G->V) {
        printf("\n %d: ", j);
        for (i = 0; i < G->V; i++) {
	    if (pred[i] == j) {
	       printf("%d ", i);
	    }
        }
        j++;
   }
   printf("\n");

   return 0;
}